%define libname_orig	lib%{name}

%define major		0
%define libname		%mklibname %{name} %{major}
%define libnamedev	%mklibname %{name} -d

%define major_1		1
%define libavcall	%mklibname avcall %{major_1}
%define libcallback	%mklibname callback %{major_1}
%define libtrampoline	%mklibname trampoline %{major_1}

Summary:	Libraries that can be used to build foreign function call interfaces
Name:		ffcall
Version:	2.5
Release:	%mkrel 1
License:	GPLv2+
Group:		System/Libraries
URL:		https://www.gnu.org/software/libffcall
Source:		https://ftp.gnu.org/gnu/libffcall/%{libname_orig}-%{version}.tar.gz

%description
This is a collection of four libraries which can be used to build
foreign function call interfaces in embedded interpreters.

The four packages are:

    avcall - calling C functions with variable arguments

    vacall - C functions accepting variable argument prototypes

    trampoline - closures as first-class C functions

    callback - closures with variable arguments as first-class C functions
    (a reentrant combination of vacall and trampoline)

This version B includes some minor configuration changes so that files
are installed in the proper place. Also it compiles on cygwin and mingw32.

%package        -n %{libname}
Summary:        Libraries that can be used to build foreign function call interfaces
Group:          System/Libraries
Provides:       %{libname_orig} = %{version}-%{release}
Conflicts:      %{_lib}%{name}-devel < 2.5-1

%description -n %{libname}
This is a collection of four libraries which can be used to build
foreign function call interfaces in embedded interpreters.

The four packages are:

    avcall - calling C functions with variable arguments

    vacall - C functions accepting variable argument prototypes

    trampoline - closures as first-class C functions

    callback - closures with variable arguments as first-class C functions
    (a reentrant combination of vacall and trampoline)

This version B includes some minor configuration changes so that files
are installed in the proper place. Also it compiles on cygwin and mingw32.

%package        -n %{libavcall}
Summary:        FFI library for variadic argument functions
Group:          System/Libraries

%description -n %{libavcall}
A library for building foreign function call interfaces in embedded
interpreters.
This library allows calling C functions with variable argument
prototypes.

%package        -n %{libcallback}
Summary:        FFI library for closures with variable arguments
Group:          System/Libraries

%description -n %{libcallback}
A library for building foreign function call interfaces in embedded
interpreters.
This library allows for closures with variable arguments as
first-class C functions (a reentrant combination of vacall and
trampoline).

%package        -n %{libtrampoline}
Summary:        FFI library for closures as first-class C functions
Group:          System/Libraries

%description -n %{libtrampoline}
A library for building foreign function call interfaces in embedded
interpreters.
This library allows using closures (lambdas) as first-class C
functions.

%package -n %{libnamedev}
Summary:	Development package for %{name}
Group:		Development/C++
Requires:	%{libname} = %{version}-%{release}
Requires:	%{libavcall} = %{version}-%{release}
Requires:	%{libcallback} = %{version}-%{release}
Requires:	%{libtrampoline} = %{version}-%{release}
Provides:	%{libname_orig}-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}

%description -n %{libnamedev}
Header files for development with %{name}.

%prep
%autosetup -p1 -n %{libname_orig}-%{version}

%build
%configure
# parallel make still fails as of 1.13
make

%install
%make_install

# ensure .so modules are executable for proper -debuginfo extraction
chmod a+x %{buildroot}%{_libdir}/lib*.so.*

mkdir -p %{buildroot}%{_defaultdocdir}/%{libnamedev}
mv %{buildroot}/usr/share/html %{buildroot}%{_defaultdocdir}/%{libnamedev}/html

%files -n %{libname}
%{_libdir}/libffcall.so.%{major}{,.*}

%files -n %{libavcall}
%{_libdir}/libavcall.so.%{major_1}{,.*}

%files -n %{libcallback}
%{_libdir}/libcallback.so.%{major_1}{,.*}

%files -n %{libtrampoline}
%{_libdir}/libtrampoline.so.%{major_1}{,.*}

%files -n %{libnamedev}
%doc NEWS README PLATFORMS
%{_defaultdocdir}/%{libnamedev}/html/
%{_includedir}/*.h
%{_libdir}/*.a
%{_libdir}/libavcall.so
%{_libdir}/libcallback.so
%{_libdir}/libffcall.so
%{_libdir}/libtrampoline.so
%{_mandir}/man3/*.3*


%changelog
* Fri Sep 06 2024 daviddavid <daviddavid> 2.5-1.mga10
+ Revision: 2093332
- new version: 2.5
- split out all shared libs in their own sub-pkgs
- re-enable debug packages as it should

* Tue Mar 15 2022 umeabot <umeabot> 2.4-2.mga9
+ Revision: 1793776
- Mageia 9 Mass Rebuild

* Mon Jan 17 2022 mrambo3501 <mrambo3501> 2.4-1.mga9
+ Revision: 1768860
- version 2.4

* Thu Feb 13 2020 umeabot <umeabot> 1.13-3.mga8
+ Revision: 1512221
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Sun Sep 23 2018 umeabot <umeabot> 1.13-2.mga7
+ Revision: 1297685
- Mageia 7 Mass Rebuild

* Fri Jun 30 2017 akien <akien> 1.13-1.mga6
+ Revision: 1108774
- Version 1.13 (mga#21140)

* Wed Mar 16 2016 daviddavid <daviddavid> 1.12-3.mga6
+ Revision: 991705
- rediff unappliable make-jN patch (since fixed autopatch)

* Thu Feb 11 2016 pterjan <pterjan> 1.12-2.mga6
+ Revision: 955969
- Drop broken requires

* Thu Feb 11 2016 pterjan <pterjan> 1.12-1.mga6
+ Revision: 955920
- Update to 1.12
- Drop non static lib, not sure where it came from

* Sun Oct 18 2015 daviddavid <daviddavid> 1.10-13.mga6
+ Revision: 892492
- add more docs to fix build with latest rpm
+ neoclust <neoclust>
- Fix build with new rpm ( empty debuginfo)

* Wed Oct 15 2014 umeabot <umeabot> 1.10-12.mga5
+ Revision: 739937
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1.10-11.mga5
+ Revision: 679164
- Mageia 5 Mass Rebuild

* Fri Oct 18 2013 umeabot <umeabot> 1.10-10.mga4
+ Revision: 504440
- Mageia 4 Mass Rebuild

* Fri Jan 11 2013 umeabot <umeabot> 1.10-9.mga3
+ Revision: 350256
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Fri Feb 25 2011 dmorgan <dmorgan> 1.10-8.mga1
+ Revision: 59898
- Remove mdv macros
- imported package ffcall


* Sat Sep 18 2010 Funda Wang <fwang@mandriva.org> 1.10-8mdv2011.0
+ Revision: 579336
- add missing requires

* Tue Aug 24 2010 Funda Wang <fwang@mandriva.org> 1.10-7mdv2011.0
+ Revision: 572780
- add patch to build in parallel

* Thu Sep 03 2009 Thierry Vignaud <tv@mandriva.org> 1.10-6mdv2010.0
+ Revision: 428718
- rebuild

* Fri Jul 18 2008 Funda Wang <fwang@mandriva.org> 1.10-5mdv2009.0
+ Revision: 238018
- Build with -fPIC

* Fri Jul 11 2008 Funda Wang <fwang@mandriva.org> 1.10-4mdv2009.0
+ Revision: 233843
- should be obsoletes rather than conflicts

* Fri Jul 11 2008 Funda Wang <fwang@mandriva.org> 1.10-3mdv2009.0
+ Revision: 233827
- use configure2_5x

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Tue Feb 12 2008 Frederik Himpe <fhimpe@mandriva.org> 1.10-3mdv2008.1
+ Revision: 166454
- Fix summary
- Clean buildroot
- Fix devel package provides
- Remove shared libraries from -devel package and put them in lib package
- Adapt devel package name to new policy

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request
    - fix summary-ended-with-dot


* Mon Apr 02 2007 Pascal Terjan <pterjan@mandriva.org> 1.10-2mdv2007.1
+ Revision: 150177
- Use the macros, this avoids a lot of hacks and fixes build on x86_64
- Use mkrel
- Use autoconf2.5
- Fix group
- Don't have 2 dirs for the doc
- Import ffcall

* Sat Jun 05 2004 Lenny Cartier <lenny@mandrakesoft.com> 1.10-1mdk
- 1.10

* Sat May 15 2004 Lenny Cartier <lenny@mandrakesoft.com> 1.9-1mdk
- 1.9

